# Generated by Django 3.0.6 on 2020-05-10 18:19

import pandas as pd
from django.db import migrations
from django.conf import settings


def fill_teachers(apps, schema_editor):
    Teacher = apps.get_model('spbstu', 'Teacher')
    df = pd.read_excel(settings.DB_EXCEL_DIR / 'Teachers.xlsx', header=None).fillna('')
    teachers = []
    for i, row in df.iterrows():
        if short_name := row[12]:
            if not (rate := row[10]):
                print(f'Problems with {row}')
                continue
            last_name, *_ = short_name.split()
            teachers.append(Teacher(
                position=row[9],
                rate=rate,
                financing_source=row[11],
                short_name=short_name,
                first_name=row[13],
                patronymic=row[14],
                last_name=last_name,
            ))
        else:
            print(f'Problems with {row}')
    Teacher.objects.bulk_create(teachers)


def drop_teachers(apps, schema_editor):
    Teacher = apps.get_model('spbstu', 'Teacher')
    Teacher.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ('spbstu', '0007_teacher_short_name'),
    ]

    operations = [
        migrations.RunPython(fill_teachers, drop_teachers)
    ]
